# Resource

1. [feeler yt-video](https://www.youtube.com/watch?v=iRJ4uab_NIg)
2. [chain of though paper](https://arxiv.org/abs/2201.11903)

# Questions

|Timestamp|Context|Question|
|--|--|--|
|0:44|He said: "you can give a prompt like `5558 * 345` and have chat gpt use a tool like calculator program - invoke it and get the results" <br> <br> Basically: What is the role of `langchain`? How does `langchain` work? In what exact way did langchain allow chatGPT to use a calculator |1. Bitto: It doesn' make sense to say chat GPT which is basic generating texts is talking to an external program, it would have to be the tool -- `langChain` which somehow connects these. If this correct, for a use case if a bunch of tools need to be used in some **fashion** - how data should be transfered between what tools that should be programatically written each use case. <br> <br> 2. Jibin: It is not case by case programming done by coding by programmers where a programmer orchestrates the data for each AI enhanced scenario, but something more complicated. <br> <br> 3. Karthik: Based on my limited deep dive: Chat GPT is the orchestrator. <br> - Orchestration facilitator: Linux pipe `\|` ; <br> - grep, cat, exec, ls are the tools which are pulled together ; <br> - There is an orchestration script written by a human ; <br> - To write the script the human needs to know about how the tools work and what the problem is - using that knowledge human writes a orachestration script. <br> <br> In the case of chat GPT + langchain <br> - langchain is the orchestration engine;  <br> - tools can be any program that can be connected to langchain in the same way any program can be connected to a linux shell <br> - Orchestration script is written by chat GPT. <br> - The knowledge required to write the script can be provided as a prompt. <br> <br> 4. Jibin: Is it really that easy to set a context and inform the AI <br> - 1. All the tools that are available <br> - 2. What are the rules to use those tools <br> - 3. Is chat GPT good enough to reason about the tools and come up with the correct orschestration script for the problem for fairly complex / real life / userful problems <br> <br> 5. Karthik: This question will be answered by the paper on `chain of thought`.|
|9:45|There is a lenght guessing (see video for more details)|For small word length like 6, 5, 3, the fact that it has developed a notion of length for small word sizes it becomes evident. But it also looks like for anything bigger than a small word size, it is all just 'really big words' in the chat GPT's mind. This is similar to indigenous tribes - they have notion of number upto 10, everyting greater than 10 is 'a lot'. Another way to look at this is like -- if you use your 'eyes' to get a count without mentally counting or saying 1,2,3,.. you might be able to count upto 4 or something but beyond that your eyes image ability will not let you figure the count. So, language ability might be kind of like that.|
|10:47|It said it got an answer, but here it made a mistake in the orchestration.| We honestly don't know if <br> > - the convo got too long and it lost context, or <br> > - whether it was being confidently wrong. <br> > - or maybe we just have to deal with the fact that it can be wrong sometimes but come up some safetey mechanism to workaround it. After humans can also be confidently wrong.|

# Some random thoughts

1. Instead of guessing the correct method (in case of REPL (python)) what if it was provided documentation.
2. If documentation needs to be parsed, a challege would be what if the documentation is itself is too big and just getting one answer for a documentation realted question -- say `what is the name of this function` itself exhausts the token limit.
> - solution 1: make ability to get a new chat gpt instance and call it a tool available in lang chain
> - solution 2: vectorisation and vector db searching
3. The things that chat gpt did - or rather the reasoning that it log - resembled kind of what a beginner programmer would do, or even for that matter what a seasoned programmer would do, if said programmer was in the same situation as chat gpt -- no autocompletion , no access to documentation & a mandate to write the program no matter how inefficient it is given the lack of information.
4. All of this sound like 1970s were smart soft engineers were coming up with inventive ways to work around the small ram space -- like trying to create the First Person Shooter (3D) video game Doom in 64 KiB RAM.
5. Jibin: a core chat GPT related question : even if it was trained on hundreds of thousands of codebases in github for python -- how is it able to translate an english requirement to this. -- open question -- don't know -- maybe deep philosophical -- at end of the day, we can more or less treat this as a black box to proceed.
6. Karthik: Actual training -- needs lots of data, supervisation or adverserial -- telling the model whether a given predictio is right, then backpropagating and changing the weight -- aka rewiring the model. That is kind of hard wiring a circuit for a specific requirement (like a circuit to do addition -- adder circuit or a circuit for a boolean conditiona). Single shot, double shot training (these are terms I saw first in the `chain of thought` paper) is this idea that LLMs have become so advanced you no longer need to train an AI to do a specific task, you can provide a few example prompts to teach it (equivalent in the analogy for this would be writing a program) temporarily -- temporarily in the sense that the new single/double shot training knowledge that has been given to chat GPT is volatile, kind of like the program in RAM. LLM is like a universal Turing machine (if it were not limited by the limited token size / attention -- which is like the equivalent of RAM).
7. Jibin: If the above is true, then chat GPT already knows (as in hard wired -- as in trained -- not single shot or double shot) python, then you can use prompting to teach it java using prompting alone much more efficient (in terms of time and training resources) than it took for training it python. Of course this knowledge would be volatile as it exists in the context. Also, at the moment the token size is too small as the technical limits of token size / attention is currently where tech limits for ram size was in say 1970s. Examples: would be using comparison (where we use LLMs high comprehension capability -- saying "the equivalent of enum is this") and maybe not even using comparisons where it will figure out based on similarities. seeing the keyword `class` using in the training prompt for java, using the syntax familiarity of python, it might even guess we are talking about something similar to the notion of `class` in python, even if we don't say.

# Next steps

1. Go through the paper on chain of thought to get answers some of the open questions